#ifndef _HEXDUMP_H_
#define _HEXDUMP_H_ 1

#include <string>
#include <vector>
#include "exceptions.h"

long be2le(long x);
unsigned long be2le(unsigned long x);
short be2le(short x);

std::string rawbytes(void * start, long bytecount);
std::string hexdump(void * start, long bytecount, unsigned long base = 0);
std::string hex(unsigned int x);
std::string hex(std::string x);
std::string lpad(std::string x, int tot, char pad =' ');
std::string rpad(std::string x, int tot, char pad =' ');
std::string str(BYTE * s, int len);
std::string str(int x);
std::string stamptotime(unsigned int t, bool showzero = false);
std::string majmin(int maj, int mn);
std::string hex_range(int start, int size);
std::string tolower(std::string s);
void split(std::vector<std::string> & outv, std::string & ins, std::string splitchars);
std::string symbol_name(IMAGE_SYMBOL & s, byte * stringtable);

#endif