#ifndef _MMF_H_ 
#define _MMF_H_ 1

#include "windows.h"
#include <string>
#include "boost/shared_ptr.hpp"

class memory_mapped_file
{
public:
	typedef boost::shared_ptr<memory_mapped_file> ptr;

	enum errMMF {   errMMF_NoError, errMMF_FileOpen,
		            errMMF_FileMapping, errMMF_MapView };
private:
    HANDLE      m_hFile;
    HANDLE      m_hFileMapping; // Handle of memory mapped file
    PVOID       m_pMemoryMappedFileBase;
    DWORD       m_cbFile;
    errMMF      m_errCode;  
private:
	memory_mapped_file(const memory_mapped_file & other);
	memory_mapped_file & operator =(const memory_mapped_file & other);
public:
	memory_mapped_file(const _TCHAR * fname);
	~memory_mapped_file();
	void * get_base() { return m_pMemoryMappedFileBase; }
	long   get_size() const { return m_cbFile; }
	bool   is_valid() const { return errMMF_NoError == m_errCode; } 
	errMMF get_status() const { return m_errCode; }
};

#endif