#include "stdafx.h"
#include <string>

typedef void*(*  malloc_func_t )(size_t);
typedef void (*  free_func_t )  (void *);
typedef char*(*  __unDNameEx_t) (char* buffer, const char* mangled, int buflen, malloc_func_t memget, free_func_t memfree, void* unknown, unsigned short int flags );


__unDNameEx_t get_undname()
{
	HANDLE h;
	h = GetModuleHandleA("msvcr80.dll");
	if (!h) h = GetModuleHandleA("msvcr80d.dll");
	if (!h) h = GetModuleHandleA("msvcr90.dll");
	if (!h) h = GetModuleHandleA("msvcr90d.dll");
	if (!h) throw std::runtime_error("Can't find msvc runtime.");
	__unDNameEx_t p = (__unDNameEx_t)GetProcAddress((HMODULE)h, "__unDNameEx");
	return p;
}


std::string unmangle(std::string sym)
{
	std::string outprefix = "";
	static __unDNameEx_t und = NULL;
	if (!und) und = get_undname();
	char * szUndName = NULL;

	if (sym.length() > 6 && sym[0] == '_')
	{
		bool trim = false;
		int np = sym.find_first_of("?");
		if (np != std::string::npos)
		{
			std::string prefix = sym.substr(0, np);
			if (prefix == "__imp_")
			{
				trim = true;
				outprefix = "__declspec(dllimport) ";
			}
		}
		if (trim)
		{
			sym = sym.substr(np);
		}
	}

	if (0 != (szUndName = und( 0, sym.c_str()
		, 0, malloc, free, 0, 0 /* UNDNAME_COMPLETE */ )))
	{
		std::string ret = szUndName;
		free(szUndName);
		if (ret == sym) return "";
		return outprefix + ret;
	}
	else
	{
		return "";
	}
}

