#include "stdafx.h"

#include "BinDoc.h"
#include "..\..\dumpbin\dumpbin\dumpbin.h"

using namespace wb2;

void MarshalString ( System::String^ s, std::string& os ) 
{
   using namespace System::Runtime::InteropServices;
   const char* chars = 
	  (const char*)(Marshal::StringToHGlobalAnsi(s)).ToPointer();
   os = chars;
   Marshal::FreeHGlobal(System::IntPtr((void*)chars));
}

class wb2::BinDocImpl
{
public:
	result_heirachy::ptr m_data;
private:
	BinDocImpl(const BinDocImpl & other);
	BinDocImpl & operator=(const BinDocImpl & other);
public:
	BinDocImpl() {}
};


BinDoc::BinDoc()
{
	m_bdi = new BinDocImpl();
}

bool BinDoc::IsError()
{
	return (!(m_bdi->m_data) || m_bdi->m_data->is_error());
}

/*
 * May throw.
 */
System::Void BinDoc::LoadFile(System::String ^ fname)
{
	std::string sfname;
	MarshalString(fname, sfname);

	result_heirachy::ptr processed_file = process_file(sfname,false);
	m_bdi->m_data = processed_file;
}

System::Windows::Forms::TreeNode ^ process_bd_tree(result_heirachy::ptr & rh, int idx)
{
	cli::array<System::Windows::Forms::TreeNode ^> ^ children;

	std::vector<int> kids = rh->get_children(idx);
	if (!kids.empty())
	{
		children = gcnew cli::array<System::Windows::Forms::TreeNode ^>(kids.size());
	}
	unsigned int outidx = 0;
	for (std::vector<int>::iterator vit = kids.begin(); vit != kids.end(); ++vit)
	{
		System::Windows::Forms::TreeNode ^ kid = process_bd_tree(rh, *vit);
		if (kid)
		{
			children[outidx++] = kid;
		}
	}

	System::Windows::Forms::TreeNode ^ tn;
	System::String ^ name = gcnew System::String(rh->get_node(idx)->get_name().c_str());
	if (children)
	{
		tn = gcnew System::Windows::Forms::TreeNode(name, children);
	}
	else
	{
		tn = gcnew System::Windows::Forms::TreeNode(name);
	}
	tn->Tag = idx;
	return tn;
}


System::Windows::Forms::TreeNode ^ BinDoc::get_Nodes()
{
//	std::map<dbobj *, unsigned long> processed;
//	std::vector<dbobj *> indexed;

	System::Windows::Forms::TreeNode ^ res = process_bd_tree(m_bdi->m_data, 0);
	return res;
}

System::String ^ BinDoc::get_Text(int node_id)
{
	std::string str = m_bdi->m_data->get_node(node_id)->get_display();
	System::String ^ cs = gcnew System::String(str.c_str());
	return cs;
}