/* 
 * Simple graphical wrapper around dumpbin.dll - allows us to view the data structures in a nice
 * heirachical form rather than linearly.
 *
 * lee@benf.org
 */

#include "stdafx.h"
#include "WumpMain.h"
#include "AboutDialog.h"
using namespace System::Threading;

using namespace wb2;

delegate System::Void AddDocDelegate(BinDoc ^); 

public ref class LoadStarter
{
	WumpMain ^ frm_owner;
	System::String ^ m_fname;
public:
	LoadStarter(WumpMain ^ owner, System::String ^ fname) : frm_owner(owner), m_fname(fname) {}
	void DoBegin(void)
	{
		BinDoc ^ b = gcnew BinDoc();
		// This should be the expensive bit...
		b->LoadFile(m_fname);

		if (b->IsError())
		{
		}
		else
		{
			AddDocDelegate ^ dd = gcnew AddDocDelegate(frm_owner, &WumpMain::AddDocument);
			frm_owner->Invoke(dd, b);
		}
	}
};

System::Void WumpMain::openToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e)
{
	OpenFileDialog ^ fd = gcnew OpenFileDialog();
	fd->Filter = "Dynamic Libraries (*.dll)|*.dll|Exe files (*.exe)|*.exe|Object files (*.obj)|*.obj|Static Libraries (*.lib)|*.lib|All files (*.*)|*.*";
	fd->ShowDialog(this);
	System::String ^ s = fd->FileName;

	LoadStarter ^ ls = gcnew LoadStarter(this, s);

	ThreadStart^ threadDelegate = gcnew ThreadStart( ls, &LoadStarter::DoBegin );
	Thread thread1( threadDelegate ) ;
	thread1.Start() ;
	
}

System::Void WumpMain::AddDocument(wb2::BinDoc ^doc)
{
	m_doc = doc; // temp.
	treeView1->Nodes->Add(doc->get_Nodes());
	treeView1->ExpandAll();
}

System::Void WumpMain::treeView1_AfterSelect(System::Object^  sender, System::Windows::Forms::TreeViewEventArgs^  e)
{
	System::Int32 ^ x = (System::Int32 ^ )treeView1->SelectedNode->Tag;
	int xx = *x;
	m_rtbDisplay->Text = m_doc->get_Text(xx);
}


System::Void WumpMain::aboutToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e)
{
	AboutDialog ^ d = gcnew AboutDialog();
	d->ShowDialog();
}
